#! /bin/bash
# **********线下爬虫********** #
env=$1          # 爬虫运行环境，正式环境: prod / 测试环境: dev
#echo ${env}
if [ ${env} = "dev" ];then
  piaoquan_crawler_dir=/Users/wangkun/Desktop/crawler/piaoquan_crawler/
  profile_path=/etc/profile
  node_path=/opt/homebrew/bin/node
  log_path=${piaoquan_crawler_dir}main/main_logs/process-$(date +%Y-%m-%d).log
else
  piaoquan_crawler_dir=/Users/piaoquan/Desktop/piaoquan_crawler/
  profile_path=./base_profile
  node_path=/usr/local/bin/node
  log_path=${piaoquan_crawler_dir}main/main_logs/process-$(date +%Y-%m-%d).log
fi

time=$(date +%H:%M:%S)
echo "$(date "+%Y-%m-%d %H:%M:%S") 更新环境变量..." >> ${log_path}
cd ~ && source ${profile_path}
echo "$(date "+%Y-%m-%d %H:%M:%S") 更新环境变量完成！" >> ${log_path}

echo "$(date "+%Y-%m-%d %H:%M:%S") 正在重启Appium..." >> ${log_path}
ps -ef | grep "/Applications/Appium.app/Contents/Resources/app/node_modules/appium/build/lib/main.js" | grep -v "grep"
if [ "$?" -eq 1 ];then
  echo "$(date "+%Y-%m-%d %H:%M:%S") Appium异常停止,正在重启!" >> ${log_path}
  nohup ${node_path} /Applications/Appium.app/Contents/Resources/app/node_modules/appium/build/lib/main.js >>./nohup.log 2>&1 &
  echo "$(date "+%Y-%m-%d %H:%M:%S") 重启Appium完毕!" >> ${log_path}
else
  echo "$(date "+%Y-%m-%d %H:%M:%S") Appium 进程状态正常" >> ${log_path}
fi

# 知青天天看
if [[ "$time" > "00:00:00" ]] && [[ "$time" < "08:59:59" ]]; then
  echo "$(date "+%Y-%m-%d %H:%M:%S") 开始启动 知青天天看 爬虫脚本任务" >> ${log_path}
#  adb kill-server
#  adb start-server
  ps aux | grep run_zhongmiaoyinxin | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_ganggangdouchuan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_jixiangxingfu | grep -v grep | awk '{print $2}' | xargs kill -9
  ps -ef | grep "run_zhiqingtiantiankan_recommend.py" | grep -v "grep"
  if [ "$?" -eq 1 ];then
    echo "$(date "+%Y-%m-%d %H:%M:%S") 知青天天看小程序爬虫, 异常停止, 正在重启!" >> ${log_path}
    cd ${piaoquan_crawler_dir}
    nohup python3 -u zhiqingtiantiankan/zhiqingtiantiankan_main/run_zhiqingtiantiankan_recommend.py --log_type="recommend" --crawler="zhiqingtiantiankan" --env=${env} >>zhiqingtiantiankan/logs/nohup-recommend.log 2>&1 &
    echo "$(date "+%Y-%m-%d %H:%M:%S") 重启完成!" >> ${log_path}
  else
    echo "$(date "+%Y-%m-%d %H:%M:%S") 知青天天看小程序爬虫, 进程状态正常" >> ${log_path}
  fi
else
  echo "$(date "+%Y-%m-%d %H:%M:%S") 知青天天看 爬虫脚本任务结束" >> ${log_path}
fi

# 刚刚都传
if [[ "$time" > "09:00:00" ]] && [[ "$time" < "12:59:59" ]]; then
  echo "$(date "+%Y-%m-%d %H:%M:%S") 开始启动 刚刚都传 爬虫脚本任务" >> ${log_path}
#  adb kill-server
#  adb start-server
  ps aux | grep run_zhongmiaoyinxin | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_zhiqingtiantiankan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_jixiangxingfu | grep -v grep | awk '{print $2}' | xargs kill -9
  ps -ef | grep "run_ganggangdouchuan_recommend.py" | grep -v "grep"
  if [ "$?" -eq 1 ];then
    echo "$(date "+%Y-%m-%d %H:%M:%S") 刚刚都传小程序爬虫, 异常停止, 正在重启!" >> ${log_path}
    cd ${piaoquan_crawler_dir}
    nohup python3 -u ganggangdouchuan/ganggangdouchuan_main/run_ganggangdouchuan_recommend.py --log_type="recommend" --crawler="ganggangdouchuan" --env=${env} >>ganggangdouchuan/logs/nohup-recommend.log 2>&1 &
    echo "$(date "+%Y-%m-%d %H:%M:%S") 重启完成!" >> ${log_path}
  else
    echo "$(date "+%Y-%m-%d %H:%M:%S") 刚刚都传小程序爬虫, 进程状态正常" >> ${log_path}
  fi
else
  echo "$(date "+%Y-%m-%d %H:%M:%S") 刚刚都传小程序爬虫, 任务结束" >> ${log_path}
fi

# 吉祥幸福
if [[ "$time" > "13:00:00" ]] && [[ "$time" < "16:59:59" ]]; then
  echo "$(date "+%Y-%m-%d %H:%M:%S") 开始启动 吉祥幸福 爬虫脚本任务" >> ${log_path}
#  adb kill-server
#  adb start-server
  ps aux | grep run_zhongmiaoyinxin | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_zhiqingtiantiankan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_ganggangdouchuan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps -ef | grep "run_jixiangxingfu_recommend.py" | grep -v "grep"
  if [ "$?" -eq 1 ];then
    echo "$(date "+%Y-%m-%d %H:%M:%S") 吉祥幸福爬虫, 异常停止, 正在重启!" >> ${log_path}
    cd ${piaoquan_crawler_dir}
    nohup python3 -u jixiangxingfu/jixiangxingfu_main/run_jixiangxingfu_recommend.py --log_type="recommend" --crawler="jixiangxingfu" --env=${env} >>jixiangxingfu/logs/nohup-recommend.log 2>&1 &
    echo "$(date "+%Y-%m-%d %H:%M:%S") 重启完成!" >> ${log_path}
  else
    echo "$(date "+%Y-%m-%d %H:%M:%S") 吉祥幸福 进程状态正常" >> ${log_path}
  fi
else
  echo "$(date "+%Y-%m-%d %H:%M:%S") 吉祥幸福 爬虫脚本任务结束" >> ${log_path}
fi

# 众妙音信
if [[ "$time" > "17:00:00" ]] && [[ "$time" < "23:59:59" ]]; then
  echo "$(date "+%Y-%m-%d %H:%M:%S") 开始启动 众妙音信 爬虫脚本任务" >> ${log_path}
#  adb kill-server
#  adb start-server
  ps aux | grep run_ganggangdouchuan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_zhiqingtiantiankan | grep -v grep | awk '{print $2}' | xargs kill -9
  ps aux | grep run_jixiangxingfu | grep -v grep | awk '{print $2}' | xargs kill -9
  ps -ef | grep "run_zhongmiaoyinxin_recommend.py" | grep -v "grep"
  if [ "$?" -eq 1 ];then
    echo "$(date "+%Y-%m-%d %H:%M:%S") 众妙音信小程序爬虫, 异常停止, 正在重启!" >> ${log_path}
    cd ${piaoquan_crawler_dir}
    nohup python3 -u zhongmiaoyinxin/zhongmiaoyinxin_main/run_zhongmiaoyinxin_recommend.py --log_type="recommend" --crawler="zhongmiaoyinxin" --env=${env} >>zhongmiaoyinxin/logs/nohup-recommend.log 2>&1 &
    echo "$(date "+%Y-%m-%d %H:%M:%S") 重启完成!" >> ${log_path}
  else
    echo "$(date "+%Y-%m-%d %H:%M:%S") 众妙音信小程序爬虫, 进程状态正常" >> ${log_path}
  fi

else
  echo "$(date "+%Y-%m-%d %H:%M:%S") 众妙音信 爬虫脚本任务结束" >> ${log_path}
fi

# 删除日志
echo "$(date "+%Y-%m-%d %H:%M:%S") 开始清理 10 天前的日志文件" >> ${log_path}
find ${piaoquan_crawler_dir}main/main_logs/ -mtime +10 -name "*.log" -exec rm -rf {} \;
echo "$(date "+%Y-%m-%d %H:%M:%S") 日志文件清理完毕" >> ${log_path}
exit 0